## 01_serverlist.dpatch by evo, edited by bartm, edited by asisak, edited by
## warp10, ember
##
## DP: Add debian and chillfactory irc servers.
## DP: Make Debian servers default.
## DP: Remove Aitvaras IPV6 servers
## DP: Connect irc.ubuntu.com and irc.freelists.org to port 8001.
## DP: Fix oz.org referred as "OzNet" and conncting to wrong servers.
## DP: Refresh patch for 2.8.6

diff -urNad xchat-2.8.6~/src/common/servlist.c xchat-2.8.6/src/common/servlist.c
--- xchat-2.8.6~/src/common/servlist.c	2008-04-01 09:22:34.000000000 +0100
+++ xchat-2.8.6/src/common/servlist.c	2008-06-22 13:27:45.000000000 +0100
@@ -46,6 +46,12 @@
 
 static const struct defaultserver def[] =
 {
+	{"Debian Servers", 0, "#debian"},
+	{0,                     "irc.debian.org"},
+
+	{"Ubuntu Servers", 0, "#ubuntu"},
+	{0,                     "irc.ubuntu.com/8001"},
+
 	{"2600net",	0},
 	{0,			"irc.2600.net"},
 
@@ -59,12 +65,12 @@
 	{0,			"eu.afternet.org"},
 
 	{"Aitvaras",	0},
-#ifdef USE_IPV6
+/*#ifdef USE_IPV6
 #ifdef USE_OPENSSL
 	{0,			"irc6.ktu.lt/+7668"},
 #endif
 	{0,			"irc6.ktu.lt/7666"},
-#endif
+#endif*/
 #ifdef USE_OPENSSL
 	{0,			"irc.data.lt/+6668"},
 	{0,			"irc-ssl.omnitel.net/+6668"},
@@ -137,6 +143,9 @@
 	{"ChatSpike", 0},
 	{0,			"irc.chatspike.net"},
 
+	{"ChillFactory", 0},
+	{0,                     "irc.chillfactory.net"},
+
 	{"CoolChat",	0},
 	{0,			"irc.coolchat.net"},
 /*	{0,			"unix.coolchat.net"},
@@ -207,7 +216,7 @@
 	{0,			"irc.vendetta.com"},
 
 	{"FreeNode",	0},
-	{0,				"irc.freenode.net"},
+	{0,				"irc.freenode.net/8001"},
 
 /*	{"Freeworld",	0},
 	{0,			"kabel.freeworld.nu"},
@@ -339,7 +348,14 @@
 
 	{"OzNet",	0},
 	{0,			"irc.oz.org"},
-
+	{0,			"germany.oz.org"},
+	{0,			"sandiego.oz.org"},
+	{0,			"us.oz.org"},
+	{0,			"au.oz.org"},
+	{0,			"rockhampton.oz.org"},
+	{0,			"wollongong.oz.org"},
+	{0,			"waix.oz.org"},	
+	
 	{"PTlink",	0},
 	{0,			"irc.PTlink.net"},
 	{0,			"aaia.PTlink.net"},
@@ -900,7 +916,7 @@
 				free (net->encoding);
 				net->encoding = strdup (def[i].charset);
 			}
-			if (g_str_hash (def[i].network) == 0x8e1b96f7)
+			if (g_str_hash (def[i].network) == 0x37473b25)
 				prefs.slist_select = j;
 			j++;
 		} else
## 10_fix_unchecked_mallocs.dpatch by Paul Wise <pabs3@bonedaddy.net>
##
## DP: Fix unchecked mallocs throughout the source code.
--- a/src/common/xchat.c
+++ b/src/common/xchat.c
@@ -342,6 +342,8 @@
 	session *sess;
 
 	sess = malloc (sizeof (struct session));
+	if(sess == NULL)
+		return NULL;
 	memset (sess, 0, sizeof (struct session));
 
 	sess->server = serv;
## 20_url_pattern.dpatch by ???
##
## DP: Fix url patterns
--- a/src/fe-gtk/xtext.c
+++ b/src/fe-gtk/xtext.c
@@ -1868,7 +1868,9 @@
 		len++;
 	}
 
-	if (len > 0 && word[len-1]=='.')
+	/* ignore trailing dots and commas. */
+	/* FIXME: locales? */
+	while (len > 0 && (word[len-1]=='.' || word[len-1]==',' || word[len-1]==';'))
 	{
 		len--;
 		str--;
## 41_casecomp.dpatch by ???
##
## DP: Downloaded from http://www.phys.ethz.ch/~mweyland/casecomp.patch
## DP: this will modify tab completion so that uppercase letters will
## DP: only match to uppercase, while lowercase match bot
--- a/src/common/cfgfiles.c
+++ b/src/common/cfgfiles.c
@@ -387,6 +387,8 @@
 	{"completion_sort", P_OFFINT (completion_sort), TYPE_INT},
 	{"completion_suffix", P_OFFSET (nick_suffix), TYPE_STR},
 
+	{"completion_cinsens", P_OFFINT (completion_cinsens), TYPE_BOOL},
+
 	{"dcc_auto_chat", P_OFFINT (autodccchat), TYPE_INT},
 	{"dcc_auto_resume", P_OFFINT (autoresume), TYPE_BOOL},
 	{"dcc_auto_send", P_OFFINT (autodccsend), TYPE_INT},
--- a/src/common/util.c
+++ b/src/common/util.c
@@ -1350,7 +1350,7 @@
 	register unsigned char *s2 = (unsigned char *) str2;
 	register int res;
 
-	while ((res = rfc_tolower (*s1) - rfc_tolower (*s2)) == 0)
+	while ((res = hal_casecomp(s1,s2)) == 0)
 	{
 		s1++;
 		s2++;
@@ -1361,6 +1361,25 @@
 	return (res);
 }
 
+int
+hal_casecomp ( char *s1, char *s2)
+{
+
+/* This function, called by rfc_ncasecmp, enables enhanced tab
+ * completition: It completes te<tab> to Test but not Te<tab> to
+ * test2. (This is useful if you have two users Test1 and test2 in
+ * the channel. Can be toggeled wit /set completion_cinsens (0|1)
+ *
+ *  -- Mathias Weyland <mathias@weyland.ch>, 6.9.2004
+*/
+	if((*s2 - rfc_tolower (*s2)) || prefs.completion_cinsens)
+	{
+		return (rfc_tolower (*s1) - rfc_tolower (*s2));
+	} else {
+		return (*s1 - *s2);
+	}
+}
+
 const unsigned char rfc_tolowertab[] =
 	{ 0, 0x1, 0x2, 0x3, 0x4, 0x5, 0x6, 0x7, 0x8, 0x9, 0xa,
 	0xb, 0xc, 0xd, 0xe, 0xf, 0x10, 0x11, 0x12, 0x13, 0x14,
--- a/src/common/util.h
+++ b/src/common/util.h
@@ -26,6 +26,7 @@
 void for_files (char *dirname, char *mask, void callback (char *file));
 int rfc_casecmp (const char *, const char *);
 int rfc_ncasecmp (char *, char *, int);
+int hal_casecomp ( char *s1, char *s2);
 int buf_get_line (char *, char **, int *, int len);
 char *nocasestrstr (const char *text, const char *tofind);
 char *country (char *);
--- a/src/common/xchat.h
+++ b/src/common/xchat.h
@@ -214,6 +214,7 @@
 	unsigned int userlistbuttons;
 	unsigned int showhostname_in_userlist;
 	unsigned int nickcompletion;
+	unsigned int completion_cinsens;
 	unsigned int completion_amount;
 	unsigned int tabchannels;
 	unsigned int paned_userlist;
# Patch by Cyril Brulebois <cyril.brulebois@enst-bretagne.fr>
--- a/src/fe-gtk/fe-gtk.c
+++ b/src/fe-gtk/fe-gtk.c
@@ -934,18 +934,22 @@
 static void
 fe_open_url_inner (const char *url)
 {
+	char buf[256];
+
 #ifdef WIN32
 	ShellExecute (0, "open", url, NULL, NULL, SW_SHOWNORMAL);
 #else
 	/* universal desktop URL opener (from xdg-utils). Supports gnome,kde,xfce4. */
 	if (try_browser ("xdg-open", NULL, url))
 		return;
+	fprintf( stderr, "fe_open_url_inner: failed to open %s with xdg-open\n", url );
 
 	/* try to detect GNOME */
 	if (g_getenv ("GNOME_DESKTOP_SESSION_ID"))
 	{
 		if (try_browser ("gnome-open", NULL, url)) /* Gnome 2.4+ has this */
 			return;
+		fprintf( stderr, "fe_open_url_inner: failed to open %s with gnome-open\n", url );
 	}
 
 	/* try to detect KDE */
@@ -953,14 +957,21 @@
 	{
 		if (try_browser ("kfmclient", "exec", url))
 			return;
+		fprintf( stderr, "fe_open_url_inner: failed to open %s with kfmclient\n", url );
 	}
 
 	/* everything failed, what now? just try firefox */
 	if (try_browser ("firefox", NULL, url))
 		return;
+	fprintf( stderr, "fe_open_url_inner: failed to open %s with firefox\n", url );
+
+	if (try_browser ("mozilla", NULL, url))
+		return;
+	fprintf( stderr, "fe_open_url_inner: failed to open %s with mozilla\n", url );
 
 	/* fresh out of ideas... */
-	try_browser ("mozilla", NULL, url);
+	snprintf (buf, sizeof (buf), "Failed to open url:\n\n%s", url);
+	fe_message (buf, FE_MSG_ERROR);
 #endif
 }
 
## DP: write ignore.conf.bug463072 and rename to ignore.conf, fixes #463072.
--- a/src/common/cfgfiles.c
+++ b/src/common/cfgfiles.c
@@ -1093,6 +1093,20 @@
 		return open (buf, flags | OFLAGS);
 }
 
+int
+xchat_rename_file (char *oldpath, char *newpath, int xof_flags)
+{
+	char bufoldpath[1024];
+	char bufnewpath[1024];
+
+	if (xof_flags & XOF_FULLPATH)
+		return rename (oldpath, newpath);
+
+	snprintf (bufoldpath, sizeof (bufoldpath), "%s/%s", get_xdir_fs (), oldpath);
+	snprintf (bufnewpath, sizeof (bufnewpath), "%s/%s", get_xdir_fs (), newpath);
+	return rename (bufoldpath, bufnewpath);
+}
+
 FILE *
 xchat_fopen_file (const char *file, const char *mode, int xof_flags)
 {
--- a/src/common/cfgfiles.h
+++ b/src/common/cfgfiles.h
@@ -25,6 +25,7 @@
 void list_addentry (GSList ** list, char *cmd, char *name);
 int cmd_set (session *sess, char *tbuf, char *word[], char *word_eol[]);
 int xchat_open_file (char *file, int flags, int mode, int xof_flags);
+int xchat_rename_file (char *oldpath, char *newpath, int xof_flags);
 FILE *xchat_fopen_file (const char *file, const char *mode, int xof_flags);
 #define XOF_DOMODE 1
 #define XOF_FULLPATH 2
--- a/src/common/ignore.c
+++ b/src/common/ignore.c
@@ -304,11 +304,12 @@
 ignore_save ()
 {
 	char buf[1024];
-	int fh;
+	int fh, rc;
+	ssize_t nb;
 	GSList *temp = ignore_list;
 	struct ignore *ig;
 
-	fh = xchat_open_file ("ignore.conf", O_TRUNC | O_WRONLY | O_CREAT, 0600, XOF_DOMODE);
+	fh = xchat_open_file ("ignore.conf.bug463072", O_TRUNC | O_WRONLY | O_CREAT, 0600, XOF_DOMODE);
 	if (fh != -1)
 	{
 		while (temp)
@@ -318,11 +319,28 @@
 			{
 				snprintf (buf, sizeof (buf), "mask = %s\ntype = %d\n\n",
 							 ig->mask, ig->type);
-				write (fh, buf, strlen (buf));
+				nb = write (fh, buf, strlen (buf));
+				if( nb == (ssize_t)-1 )
+				{
+					perror( "ignore_save: write() failed" );
+					close( fh );
+					return;
+				}
 			}
 			temp = temp->next;
 		}
-		close (fh);
+		rc = close (fh);
+		if( rc != 0 )
+		{
+			perror( "ignore_save: close() failed" );
+			return;
+		}
+		rc = xchat_rename_file( "ignore.conf.bug463072", "ignore.conf", XOF_DOMODE );
+		if( rc != 0 )
+		{
+			perror( "ignore_save: xchat_rename_file() failed" );
+			return;
+		}
 	}
 
 }
## 45_brand_ctcp_version.dpatch by Daniel Holbach <daniel.holbach@ubuntu.com>
##
## All lines beginning with `## DP:' are a description of the patch.
## DP: Modify CTCP VERSION response to be branded with the Ubuntu name.

diff -urNad xchat-2.6.0~/src/common/ctcp.c xchat-2.6.0/src/common/ctcp.c
--- xchat-2.6.0~/src/common/ctcp.c	2005-10-21 11:50:58.000000000 +0200
+++ xchat-2.6.0/src/common/ctcp.c	2005-12-20 09:48:11.000000000 +0100
@@ -129,8 +129,7 @@
 
 	if (!strcasecmp (msg, "VERSION") && !prefs.hidever)
 	{
-		snprintf (outbuf, sizeof (outbuf), "VERSION xchat "PACKAGE_VERSION" %s",
-					 get_cpu_str ());
+		snprintf (outbuf, sizeof (outbuf), "VERSION xchat "PACKAGE_VERSION" Ubuntu");
 		serv->p_nctcp (serv, nick, outbuf);
 	}
 
## 46_CVE-2009-0315.dpatch by Nico Golde <nion@debian.org>
--- a/plugins/python/python.c
+++ b/plugins/python/python.c
@@ -1128,6 +1128,7 @@
 	}
 
 	PySys_SetArgv(1, argv);
+	PyRun_SimpleString("import sys; sys.path = filter(None, sys.path)");
 	PySys_SetObject("__plugin__", (PyObject *) plugin);
 
 	/* Set stdout and stderr to xchatout. */
@@ -2133,6 +2134,7 @@
 	Py_SetProgramName("xchat");
 	Py_Initialize();
 	PySys_SetArgv(1, argv);
+	PyRun_SimpleString("import sys; sys.path = filter(None, sys.path)");
 
 	Plugin_Type.ob_type = &PyType_Type;
 	Context_Type.ob_type = &PyType_Type;
## Patch by Santamar<ED>a Lema <panfaust@gmail.com>
--- a/src/common/proto-irc.c
+++ b/src/common/proto-irc.c
@@ -45,6 +45,7 @@
 {
 	if (serv->password[0])
 		tcp_sendf (serv, "PASS %s\r\n", serv->password);
+	tcp_sendf (serv, "CAP LS\r\n");
 
 	tcp_sendf (serv,
 				  "NICK %s\r\n"
@@ -1109,6 +1110,38 @@
 			return;
 		}
 	}
+
+	else if (len == 3)
+	{
+		guint32 t;
+
+		t = WORDL((guint8)type[0], (guint8)type[1], (guint8)type[2], (guint8)type[3]);
+		switch (t)
+		{
+		case WORDL('C','A','P','\0'):
+			if (strncasecmp(word[4], "ACK", 3) == 0)
+			{
+				if (strncasecmp(word[5][0]==':' ? word[5]+1 : word[5],
+					"identify-msg", 12) == 0)
+				{
+					serv->have_idmsg = TRUE;
+					tcp_send_len(serv, "CAP END\r\n", 9);
+				}
+			}
+			else if (strncasecmp(word[4], "LS", 2) == 0)
+			{
+				if (strstr(word_eol[5], "identify-msg") != 0)
+					tcp_send_len(serv, "CAP REQ :identify-msg\r\n", 23);
+				else
+					tcp_send_len(serv, "CAP END\r\n", 9);
+			}
+			else if (strncasecmp(word[4], "NAK",3) == 0)
+			{
+				tcp_send_len(serv, "CAP END\r\n", 9);
+			}
+			return;
+		}
+	}
 
 garbage:
 	/* unknown message */
## 52_fix_implicit_declaration.dpatch by Fabrice Coutadeur <fabricesp@ubuntu.com>
##
## Origin: http://lists.opensuse.org/opensuse-commit/2009-07/msg00981.html
## Description: Fix "implicitly converted to pointer at ignoregui.c:192" error.
## This fixes a FTBFS in ia64 and amd64
--- a/src/fe-gtk/ignoregui.c
+++ b/src/fe-gtk/ignoregui.c
@@ -36,6 +36,7 @@
 #include <gtk/gtkliststore.h>
 #include <gtk/gtktreeview.h>
 #include <gtk/gtktreeselection.h>
+#include <gtk/gtkcelllayout.h>
 #include <gtk/gtkcellrenderertext.h>
 #include <gtk/gtkcellrenderertoggle.h>
 
@@ -187,7 +188,7 @@
 	for (col_id=0; (col = gtk_tree_view_get_column (GTK_TREE_VIEW (view), col_id));
 	     col_id++)
 	{
-		GList *list = gtk_tree_view_column_get_cell_renderers (col);
+		GList *list = gtk_cell_layout_get_cells (GTK_CELL_LAYOUT (col));
 		GList *tmp;
 
 		for (tmp = list; tmp; tmp = tmp->next)
## Patch by <davian818@gmail.com>

=== modified file 'src/fe-gtk/plugin-tray.c'
--- old/src/fe-gtk/plugin-tray.c	2008-10-31 17:46:48 +0000
+++ new/src/fe-gtk/plugin-tray.c	2009-03-13 12:06:32 +0000
@@ -653,7 +653,7 @@
 	}
 
 	if (prefs.input_balloon_hilight)
-		tray_set_balloonf (word[2], _("XChat: Highlighted message from: %s (%s)"),
+		tray_set_balloonf (word[2], _("%s (%s)"),
 								 word[1], xchat_get_info (ph, "channel"));
 
 	return XCHAT_EAT_NONE;
@@ -678,8 +678,8 @@
 	}
 
 	if (prefs.input_balloon_chans)
-		tray_set_balloonf (word[2], _("XChat: New public message from: %s (%s)"),
-								 word[1], xchat_get_info (ph, "channel"));
+		tray_set_balloonf (word[2], _("%s (%s)"),
+								 word[1], xchat_get_info(ph, "channel"));
 
 	return XCHAT_EAT_NONE;
 }
@@ -707,8 +707,8 @@
 							tray_priv_count, from, network);
 
 	if (prefs.input_balloon_priv)
-		tray_set_balloonf (text, _("XChat: Private message from: %s (%s)"),
-								 from, network);
+		tray_set_balloonf (text, "%s",
+								 from);
 }
 
 static int
@@ -761,8 +761,8 @@
 	}
 
 	if (prefs.input_balloon_priv)
-		tray_set_balloonf ("", _("XChat: File offer from: %s (%s)"),
-								word[1], network);
+		tray_set_balloonf (_("is offering you a file."), "%s",
+								word[1]);
 
 	return XCHAT_EAT_NONE;
 }

Index: xchat-2.8.8/src/common/inbound.c
===================================================================
--- xchat-2.8.8.orig/src/common/inbound.c	2010-10-08 23:22:34.000000000 +0200
+++ xchat-2.8.8/src/common/inbound.c	2010-10-10 01:59:41.000000000 +0200
@@ -186,6 +186,9 @@
 
 	inbound_make_idtext (serv, idtext, sizeof (idtext), id);
 
+	if (alert_match_word (from, prefs.irc_no_hilight))
+		return;
+
 	sess = find_session_from_nick (from, serv);
 	if (!sess)
 	{
@@ -436,6 +439,9 @@
 
 	inbound_make_idtext (serv, idtext, sizeof (idtext), id);
 
+	if (alert_match_word (from, prefs.irc_no_hilight))
+		return;
+
 	if (is_hilight (from, text, sess, serv))
 		hilight = TRUE;
 
Description: Upstream changes introduced in version 2.8.8-3ubuntu6~test2
Author: Andreas Moog <amoog@ubuntu.com>
Bug: http://sourceforge.net/support/tracker.php?aid=3024423
Bug-Ubuntu: https://launchpad.net/bugs/392503

--- xchat-2.8.8.orig/src/fe-gtk/menu.c
+++ xchat-2.8.8/src/fe-gtk/menu.c
@@ -2215,8 +2215,10 @@ togitem:
 													 mymenu[i].state);*/
 			if (mymenu[i].key != 0)
 				gtk_widget_add_accelerator (item, "activate", accel_group,
-									mymenu[i].key, mymenu[i].id == MENU_ID_AWAY ?
-									away_mask : GDK_CONTROL_MASK, GTK_ACCEL_VISIBLE);
+									mymenu[i].key,
+									mymenu[i].id == MENU_ID_AWAY ? away_mask :
+									mymenu[i].key == GDK_F9 ? 0 :
+									GDK_CONTROL_MASK, GTK_ACCEL_VISIBLE);
 			if (mymenu[i].callback)
 				g_signal_connect (G_OBJECT (item), "toggled",
 										G_CALLBACK (mymenu[i].callback), 0);
diff -Nurp xchat-2.8.8/src/common/url.c working/src/common/url.c
--- xchat-2.8.8/src/common/url.c	2009-08-16 02:40:16.000000000 -0700
+++ working/src/common/url.c	2012-02-23 11:21:04.745059924 -0800
@@ -139,6 +139,7 @@ url_check_word (char *word, int len)
 		{ D("file://") },
 		{ D("rtsp://") },
 		{ D("ut2004://") },
+		{ D("apt:") },
 	},
 	suffix[] = {
 		{ D(".org") },
diff -Nurp xchat-2.8.8/src/fe-gtk/fe-gtk.c working/src/fe-gtk/fe-gtk.c
--- xchat-2.8.8/src/fe-gtk/fe-gtk.c	2012-02-23 11:18:22.000000000 -0800
+++ working/src/fe-gtk/fe-gtk.c	2012-02-23 11:22:42.129272865 -0800
@@ -979,7 +979,7 @@ static void
 fe_open_url_locale (const char *url)
 {
 #ifndef WIN32
-	if (url[0] != '/' && strchr (url, ':') == NULL)
+	if (url[0] != '/' && strchr (url, ':') == NULL && strncmp (url, "apt:", 4) != 0)
 	{
 		url = g_strdup_printf ("http://%s", url);
 		fe_open_url_inner (url);
## Description: Make it possible to open irc:// URI's via gvfs.
## Origin/Author: Shawn Landden <shawnlandden@gmail.com> and
## Daniel Gimpelevich <daniel@gimpelevich.san-francisco.ca.us>
## Bug: https://bugs.launchpad.net/ubuntu/+source/xchat/+bug/933822
Index: xchat-2.8.8/xchat.desktop
===================================================================
--- xchat-2.8.8.orig/xchat.desktop	2010-05-30 08:08:48.000000000 +0200
+++ xchat-2.8.8/xchat.desktop	2012-12-03 19:18:00.000000000 +0100
@@ -15,9 +15,10 @@
 Comment[ro]=Client de IRC
 Comment[zh_TW]=X-Chat 聊天程式
 Comment=Chat with other people using Internet Relay Chat
-Exec=xchat
+Exec=sh -c "xchat --existing --url %U || exec xchat"
 Icon=xchat
 Terminal=false
 Type=Application
 Categories=Network;
 StartupNotify=true
+MimeType=x-scheme-handler/irc;x-scheme-handler/ircs;
--- a/src/common/servlist.c
+++ b/src/common/servlist.c
@@ -24,7 +24,7 @@
 #include <unistd.h>
 
 #include "xchat.h"
-#include <glib/ghash.h>
+#include <glib.h>
 
 #include "cfgfiles.h"
 #include "fe.h"
--- a/src/common/text.c
+++ b/src/common/text.c
@@ -28,7 +28,7 @@
 #include <sys/mman.h>
 
 #include "xchat.h"
-#include <glib/ghash.h>
+#include <glib.h>
 #include "cfgfiles.h"
 #include "chanopt.h"
 #include "plugin.h"
--- a/src/common/util.c
+++ b/src/common/util.c
@@ -39,7 +39,7 @@
 #include <errno.h>
 #include "xchat.h"
 #include "xchatc.h"
-#include <glib/gmarkup.h>
+#include <glib.h>
 #include <ctype.h>
 #include "util.h"
 #include "../../config.h"
--- a/src/common/xchat.h
+++ b/src/common/xchat.h
@@ -1,10 +1,6 @@
 #include "../../config.h"
 
-#include <glib/gslist.h>
-#include <glib/glist.h>
-#include <glib/gutils.h>
-#include <glib/giochannel.h>
-#include <glib/gstrfuncs.h>
+#include <glib.h>
 #include <time.h>			/* need time_t */
 
 #ifndef XCHAT_H
Index: xchat-2.8.8/src/common/servlist.c
===================================================================
--- xchat-2.8.8.orig/src/common/servlist.c	2012-09-30 12:23:53.000000000 +0000
+++ xchat-2.8.8/src/common/servlist.c	2012-09-30 12:23:55.000000000 +0000
@@ -1072,6 +1072,7 @@
 servlist_save (void)
 {
 	FILE *fp;
+	int nb;
 	char buf[256];
 	ircnet *net;
 	ircserver *serv;
@@ -1080,12 +1081,12 @@
 #ifndef WIN32
 	int first = FALSE;
 
-	snprintf (buf, sizeof (buf), "%s/servlist_.conf", get_xdir_fs ());
+	snprintf (buf, sizeof (buf), "%s/servlist_.conf.bug147832", get_xdir_fs ());
 	if (access (buf, F_OK) != 0)
 		first = TRUE;
 #endif
 
-	fp = xchat_fopen_file ("servlist_.conf", "w", 0);
+	fp = xchat_fopen_file ("servlist_.conf.bug147832", "w", 0);
 	if (!fp)
 		return FALSE;
 
@@ -1093,32 +1094,32 @@
 	if (first)
 		chmod (buf, 0600);
 #endif
-	fprintf (fp, "v="PACKAGE_VERSION"\n\n");
+	nb = fprintf (fp, "v="PACKAGE_VERSION"\n\n");
 
 	list = network_list;
 	while (list)
 	{
 		net = list->data;
 
-		fprintf (fp, "N=%s\n", net->name);
+		if( nb > 0 ) nb = fprintf (fp, "N=%s\n", net->name);
 		if (net->nick)
-			fprintf (fp, "I=%s\n", net->nick);
+			if( nb > 0 ) nb = fprintf (fp, "I=%s\n", net->nick);
 		if (net->nick2)
-			fprintf (fp, "i=%s\n", net->nick2);
+			if( nb > 0 ) nb = fprintf (fp, "i=%s\n", net->nick2);
 		if (net->user)
-			fprintf (fp, "U=%s\n", net->user);
+			if( nb > 0 ) nb = fprintf (fp, "U=%s\n", net->user);
 		if (net->real)
-			fprintf (fp, "R=%s\n", net->real);
+			if( nb > 0 ) nb = fprintf (fp, "R=%s\n", net->real);
 		if (net->pass)
-			fprintf (fp, "P=%s\n", net->pass);
+			if( nb > 0 ) nb = fprintf (fp, "P=%s\n", net->pass);
 		if (net->autojoin)
-			fprintf (fp, "J=%s\n", net->autojoin);
+			if( nb > 0 ) nb = fprintf (fp, "J=%s\n", net->autojoin);
 		if (net->nickserv)
-			fprintf (fp, "B=%s\n", net->nickserv);
+			if( nb > 0 ) nb = fprintf (fp, "B=%s\n", net->nickserv);
 		if (net->encoding && strcasecmp (net->encoding, "System") &&
 			 strcasecmp (net->encoding, "System default"))
 		{
-			fprintf (fp, "E=%s\n", net->encoding);
+			if( nb > 0 ) nb = fprintf (fp, "E=%s\n", net->encoding);
 			if (!servlist_check_encoding (net->encoding))
 			{
 				snprintf (buf, sizeof (buf), _("Warning: \"%s\" character set is unknown. No conversion will be applied for network %s."),
@@ -1128,28 +1129,44 @@
 		}
 
 		if (net->command)
-			token_foreach (net->command, '\n', servlist_write_ccmd, fp);
+			if( nb > 0 )
+				if( token_foreach (net->command, '\n', servlist_write_ccmd, fp) != TRUE )
+					nb = -1;
 
-		fprintf (fp, "F=%d\nD=%d\n", net->flags, net->selected);
+		if( nb > 0 ) nb = fprintf (fp, "F=%d\nD=%d\n", net->flags, net->selected);
 
 		hlist = net->servlist;
 		while (hlist)
 		{
 			serv = hlist->data;
-			fprintf (fp, "S=%s\n", serv->hostname);
+			if( nb > 0 ) nb = fprintf (fp, "S=%s\n", serv->hostname);
 			hlist = hlist->next;
 		}
 
-		if (fprintf (fp, "\n") < 1)
-		{
-			fclose (fp);
-			return FALSE;
-		}
+		if( nb > 0 ) nb = fprintf (fp, "\n");
 
 		list = list->next;
 	}
 
-	fclose (fp);
+	if( nb <= 0 )
+	{
+		fprintf( stderr, "servlist_save: fprintf() failed\n" );
+		fclose( fp );
+		return FALSE;
+	}
+
+	if( fclose (fp) != 0 )
+	{
+		perror( "servlist_save: fclose() failed" );
+		return FALSE;
+	}
+
+	if( xchat_rename_file( "servlist_.conf.bug147832", "servlist_.conf", 0 ) != 0 )
+	{
+		perror( "servlist_save: xchat_rename_file() failed" );
+		return FALSE;
+	}
+
 	return TRUE;
 }
 
Write to temporary file and then rename.
Same approach like I did for bug 463072.
Fixes loss of data when disk is full.

diff -ruN -x '*.png' -x '*.jpg' -x '*.ogg' -x '*_image_archive' -x '*.swp' ../orig/xchat-2.8.8/src/common/tree.c ./src/common/tree.c
--- ../orig/xchat-2.8.8/src/common/tree.c	2009-08-16 09:40:16.000000000 +0000
+++ ./src/common/tree.c	2012-09-30 12:27:09.000000000 +0000
@@ -176,19 +176,27 @@
 	return 1;
 }
 
-void
-tree_foreach (tree *t, tree_traverse_func *func, void *data)
+int
+tree_foreach_int (tree *t, tree_traverse_func *func, void *data)
 {
 	int j;
 
 	if (!t || !t->array)
-		return;
+		return 1;
 
 	for (j = 0; j < t->elements; j++)
 	{
 		if (!func (t->array[j], data))
-			break;
+			return 0;
 	}
+
+	return 1;
+}
+
+void
+tree_foreach (tree *t, tree_traverse_func *func, void *data)
+{
+	tree_foreach_int( t, func, data );
 }
 
 int
diff -ruN -x '*.png' -x '*.jpg' -x '*.ogg' -x '*_image_archive' -x '*.swp' ../orig/xchat-2.8.8/src/common/tree.h ./src/common/tree.h
--- ../orig/xchat-2.8.8/src/common/tree.h	2009-08-16 09:40:16.000000000 +0000
+++ ./src/common/tree.h	2012-09-30 12:27:09.000000000 +0000
@@ -11,6 +11,7 @@
 void *tree_find (tree *t, void *key, tree_cmp_func *cmp, void *data, int *pos);
 int tree_remove (tree *t, void *key, int *pos);
 void tree_foreach (tree *t, tree_traverse_func *func, void *data);
+int tree_foreach_int (tree *t, tree_traverse_func *func, void *data);
 int tree_insert (tree *t, void *key);
 
 #endif
diff -ruN -x '*.png' -x '*.jpg' -x '*.ogg' -x '*_image_archive' -x '*.swp' ../orig/xchat-2.8.8/src/common/url.c ./src/common/url.c
--- ../orig/xchat-2.8.8/src/common/url.c	2009-08-16 09:40:16.000000000 +0000
+++ ./src/common/url.c	2012-09-30 12:27:09.000000000 +0000
@@ -50,11 +50,12 @@
 static int
 url_save_cb (char *url, FILE *fd)
 {
-	fprintf (fd, "%s\n", url);
+	if( fprintf (fd, "%s\n", url) <= 0 )
+		return FALSE;
 	return TRUE;
 }
 
-void
+int
 url_save (const char *fname, const char *mode, gboolean fullpath)
 {
 	FILE *fd;
@@ -64,10 +65,18 @@
 	else
 		fd = xchat_fopen_file (fname, mode, 0);
 	if (fd == NULL)
-		return;
+		return FALSE;
+
+	if( tree_foreach_int (url_tree, (tree_traverse_func *)url_save_cb, fd) == 0 )
+	{
+		fclose (fd);
+		return FALSE;
+	}
 
-	tree_foreach (url_tree, (tree_traverse_func *)url_save_cb, fd);
-	fclose (fd);
+	if( fclose (fd) )
+		return FALSE;
+
+	return TRUE;
 }
 
 void
diff -ruN -x '*.png' -x '*.jpg' -x '*.ogg' -x '*_image_archive' -x '*.swp' ../orig/xchat-2.8.8/src/common/url.h ./src/common/url.h
--- ../orig/xchat-2.8.8/src/common/url.h	2009-08-16 09:40:16.000000000 +0000
+++ ./src/common/url.h	2012-09-30 12:27:09.000000000 +0000
@@ -11,7 +11,7 @@
 #define WORD_DIALOG  -1
 
 void url_clear (void);
-void url_save (const char *fname, const char *mode, gboolean fullpath);
+int url_save (const char *fname, const char *mode, gboolean fullpath);
 void url_autosave (void);
 int url_check_word (char *word, int len);
 void url_check_line (char *buf, int len);
--- ../orig/xchat-2.8.8/./src/fe-gtk/urlgrab.c	2010-05-16 03:16:37.000000000 +0000
+++ ./src/fe-gtk/urlgrab.c	2012-09-30 12:36:04.000000000 +0000
@@ -136,8 +136,31 @@
 static void
 url_save_callback (void *arg1, char *file)
 {
-	if (file)
-		url_save (file, "w", TRUE);
+	if( ! file )
+		return;
+
+	char *file_tmp = malloc( strlen( file ) + strlen( ".bug147832" ) + 1 );
+	if( ! file_tmp )
+		return;
+
+	strcpy( file_tmp, file );
+	strcat( file_tmp, ".bug147832" );
+
+	if( url_save( file_tmp, "w", TRUE ) != TRUE )
+	{
+		fprintf( stderr, "url_save_callback: url_save failed (%s)\n", file_tmp );
+		free( file_tmp );
+		return;
+	}
+
+	if( xchat_rename_file( file_tmp, file, XOF_FULLPATH ) != 0 )
+	{
+		perror( "url_save_callback: xchat_rename_file() failed" );
+		free( file_tmp );
+		return;
+	}
+
+	free( file_tmp );
 }
 
 static void
Write to temporary file and then rename.
Same approach like I did for bug 463072.
Fixes loss of data when disk is full.

--- ../orig/xchat-2.8.8/./src/common/notify.c	2009-08-16 09:40:16.000000000 +0000
+++ ./src/common/notify.c	2012-09-30 12:53:27.000000000 +0000
@@ -121,25 +121,47 @@
 notify_save (void)
 {
 	int fh;
+	ssize_t nb;
 	struct notify *notify;
 	GSList *list = notify_list;
 
-	fh = xchat_open_file ("notify.conf", O_TRUNC | O_WRONLY | O_CREAT, 0600, XOF_DOMODE);
-	if (fh != -1)
+	fh = xchat_open_file ("notify.conf.bug147832", O_TRUNC | O_WRONLY | O_CREAT, 0600, XOF_DOMODE);
+	if( fh == -1 )
 	{
+		perror( "notify_save: xchat_open_file failed" );
+		return;
+	}
+	else
+	{
+		nb = 1;
 		while (list)
 		{
 			notify = (struct notify *) list->data;
-			write (fh, notify->name, strlen (notify->name));
+			if( nb > 0 ) nb = write (fh, notify->name, strlen (notify->name));
 			if (notify->networks)
 			{
-				write (fh, " ", 1);
-				write (fh, notify->networks, strlen (notify->networks));
+				if( nb > 0 ) nb = write (fh, " ", 1);
+				if( nb > 0 ) nb = write (fh, notify->networks, strlen (notify->networks));
 			}
-			write (fh, "\n", 1);
+			if( nb > 0 ) nb = write (fh, "\n", 1);
 			list = list->next;
 		}
-		close (fh);
+		if( nb <= 0 )
+		{
+			fprintf( stderr, "notify_save: fprintf() failed\n" );
+			close( fh );
+			return;
+		}
+		if( close (fh) != 0 )
+		{
+			perror( "notify_save: close failed" );
+			return;
+		}
+		if( xchat_rename_file( "notify.conf.bug147832", "notify.conf", XOF_DOMODE ) != 0 )
+		{
+			perror( "notify_save: xchat_rename_file() failed" );
+			return;
+		}
 	}
 }
 
Write to temporary file and then rename.
Same approach like I did for bug 463072.
Fixes loss of data when disk is full.

--- ../orig/xchat-2.8.8/./src/fe-gtk/palette.c	2010-05-16 03:16:10.000000000 +0000
+++ ./src/fe-gtk/palette.c	2012-09-30 12:58:02.000000000 +0000
@@ -202,25 +202,45 @@
 palette_save (void)
 {
 	int i, j, fh;
+	ssize_t nb;
 	char prefname[256];
 
-	fh = xchat_open_file ("colors.conf", O_TRUNC | O_WRONLY | O_CREAT, 0600, XOF_DOMODE);
+	fh = xchat_open_file ("colors.conf.bug147832", O_TRUNC | O_WRONLY | O_CREAT, 0600, XOF_DOMODE);
 	if (fh != -1)
 	{
+		nb = 1;
+
 		/* mIRC colors 0-31 are here */
 		for (i = 0; i < 32; i++)
 		{
 			snprintf (prefname, sizeof prefname, "color_%d", i);
-			cfg_put_color (fh, colors[i].red, colors[i].green, colors[i].blue, prefname);
+			if( nb > 0 ) nb = cfg_put_color (fh, colors[i].red, colors[i].green, colors[i].blue, prefname);
 		}
 
 		/* our special colors are mapped at 256+ */
 		for (i = 256, j = 32; j < MAX_COL+1; i++, j++)
 		{
 			snprintf (prefname, sizeof prefname, "color_%d", i);
-			cfg_put_color (fh, colors[j].red, colors[j].green, colors[j].blue, prefname);
+			if( nb > 0 ) nb = cfg_put_color (fh, colors[j].red, colors[j].green, colors[j].blue, prefname);
 		}
 
-		close (fh);
+		if( nb <= 0 )
+		{
+			fprintf( stderr, "palette_save: cfg_put_color failed\n" );
+			close( fh );
+			return;
+		}
+
+		if( close (fh) != 0 )
+		{
+			perror( "palette_save: close() failed\n" );
+			return;
+		}
+
+		if( xchat_rename_file( "colors.conf.bug147832", "colors.conf", XOF_DOMODE ) != 0 )
+		{
+			perror( "palette_save: xchat_rename_file() failed" );
+			return;
+		}
 	}
 }
Write to temporary file and then rename.
Same approach like I did for bug 463072.
Fixes loss of data when disk is full.

--- ../orig/xchat-2.8.8/./src/fe-gtk/chanlist.c	2009-08-16 09:40:18.000000000 +0000
+++ ./src/fe-gtk/chanlist.c	2012-09-30 13:09:03.000000000 +0000
@@ -480,6 +480,7 @@
 {
 	time_t t = time (0);
 	int fh, users;
+	ssize_t nb;
 	char *chan, *topic;
 	char buf[1024];
 	GtkTreeModel *model = GET_MODEL (serv);
@@ -488,14 +489,25 @@
 	if (!file)
 		return;
 
-	fh = xchat_open_file (file, O_TRUNC | O_WRONLY | O_CREAT, 0600,
+	char *file_tmp = malloc( strlen( file ) + strlen( ".bug147832" ) + 1 );
+	if( ! file_tmp )
+		return;
+
+	strcpy( file_tmp, file );
+	strcat( file_tmp, ".bug147832" );
+
+	fh = xchat_open_file (file_tmp, O_TRUNC | O_WRONLY | O_CREAT, 0600,
 								 XOF_DOMODE | XOF_FULLPATH);
 	if (fh == -1)
+	{
+		perror( "chanlist_filereq_done: xchat_open_file failed" );
+		free( file_tmp );
 		return;
+	}
 
 	snprintf (buf, sizeof buf, "XChat Channel List: %s - %s\n",
 				 serv->servername, ctime (&t));
-	write (fh, buf, strlen (buf));
+	nb = write (fh, buf, strlen (buf));
 
 	if (gtk_tree_model_get_iter_first (model, &iter))
 	{
@@ -508,12 +520,34 @@
 			snprintf (buf, sizeof buf, "%-16s %-5d%s\n", chan, users, topic);
 			g_free (chan);
 			g_free (topic);
-			write (fh, buf, strlen (buf));
+			if( nb > 0 ) nb = write (fh, buf, strlen (buf));
 		}
 		while (gtk_tree_model_iter_next (model, &iter));
 	}
 
-	close (fh);
+	if( nb <= 0 )
+	{
+		fprintf( stderr, "chanlist_filereq_done: write() failed\n" );
+		close( fh );
+		free( file_tmp );
+		return;
+	}
+
+	if( close (fh) != 0 )
+	{
+		perror( "chanlist_filereq_done: close() failed" );
+		free( file_tmp );
+		return;
+	}
+
+	if( xchat_rename_file( file_tmp, file, XOF_DOMODE | XOF_FULLPATH ) != 0 )
+	{
+		perror( "chanlist_filereq_done: xchat_rename_file() failed" );
+		free( file_tmp );
+		return;
+	}
+
+	free( file_tmp );
 }
 
 static void
Write to temporary file and then rename.
Same approach like I did for bug 463072.
Fixes loss of data when disk is full.

